class RectArray
	attr_reader :rows, :cols
	alias_method :width, :cols
	alias_method :height, :rows
	
	def initialize(rows, cols)
		@arr = Array.new(rows*cols)
		@rows = rows
		@cols = cols
	end
	
	def [](row, col)
		@arr[index(row, col)]
	end
	
	def []=(row, col, obj)
		@arr[index(row, col)] = obj
	end
	
	def flipRows!
		(@rows/2).times do|i|
			for j in 0...@cols do
				a = index(i,j)
				b = index(@rows - 1 - i,j)
				temp = @arr[a]
				@arr[a] = @arr[b]
				@arr[b] = temp
			end
		end
	end
	
	def invertCols!
		(@cols/2).times do|j|
			for i in 0...@rows do
				a = index(i,j)
				b = index(i,@cols - 1 - j)
				temp = @arr[a]
				@arr[a] = @arr[b]
				@arr[b] = temp
			end
		end
	end
	
	def insertInto(row, col, arr)
		for i in 0...(arr.rows)
			for j in 0...(arr.cols)
				self[i + row, j + col] = arr[i,j]
			end
		end
	end
	
	def to_s
		outarr = []
		for i in 0...@rows do
			inarr = []
			for j in 0...@cols do
				inarr << self[i,j]
			end
			outarr << ('[' + inarr.join(',') + ']')
		end
		
		return '[' + outarr.join(",\n ") + ']'
	end
	
	protected
	def index(row, col)
		if( (0...@rows) === row and (0...@cols) === col)
			return col + row*@cols
		else
			raise ArgumentError, 'Bad index'
		end
	end
end

class SlideRectArray < RectArray
	protected
	def index(row, col)
		return (row%@rows) + (col%@cols)*@rows
	end
end