class GameWorld
  attr_reader :space, :view_root, :objects
    
  def initialize
    @space = CP::Space.new
    
    @view_root = create_view
    
    @objects = []
    @updatables = []
  end
  
  def create_view
  	AS::Scene::Chunk.new
  end
  
  def add_game_object(obj)
    @objects << obj
    @updatables << obj if obj.respond_to?(:update)
    obj.add_to_world(self)
    #obj.add_to_space(@space) if obj.respond_to?(:add_to_space) 
    #obj.add_to_view(@view_root) if obj.respond_to?(:add_to_view)
    
    return obj
  end
  
  def remove_game_object(obj)
    obj = @objects.delete(obj)
  
    if obj
      @updatables.delete(obj)
    
    	obj.remove_from_world(self)
      #obj.remove_from_space(@space) if obj.respond_to?(:remove_from_space)
      #obj.remove_from_view(@view_root) if obj.respond_to?(:remove_from_view)
    end
    
    return obj
  end
  
  def substeps
  	1
  end
  
  def update
    @updatables.send_each(:update, self)
    
    subdt = STEP.quo(substeps)
    substeps.times{@space.step(subdt)}
  end
  
  def draw
  	GL.Color(1, 0, 0)
    @view_root.render
  end
end
