require 'as_texture.rb'

class ScoreFloatyChunk < AS::Scene::Chunk
  def initialize
    @floaties = []
  	
    super(AS::Scene::GroupNode.new(@floaties))
  end
  
  def add_floaty(p, score)
    @floaties << ScoreFloaty.new(p, score)
  end
  
  def update
    @floaties.send_each(:update)
    @floaties.delete_if{|floaty| floaty.dead?}
  end
  
  def add_to_view(chunk)
  	chunk[:floaties] = self
  end
  
  def remove_from_view(chunk)
  	chunk.remove_chunk(:floaties)
  end
end

class ScoreFloaty < AS::Scene::SpriteNode
  
  Life = 120
  Delta = vec2(0, 5)

  def initialize(p, value)
    @color = AS::PackedColor.new
  
  	child = AS::Scene::ColorNode.new(@color){
			matrix = AS::Transform2D.scale(0.15, 0.15).pack
			AS::Scene::MatrixNode.new(GL::MODELVIEW, matrix){
				TextNode.new(ThisFont, value.to_s)
			}
		}
    super(child)
    
    self.pos = p
    @p = p
    
    @life = Life
    update
  end
  
  def update
  	life = Float(Life - @life)/Life
	
		v = 1 - life
  	@color.color = AS::Color::RGB.new(v, v, v, v)
    
    self.pos = @p + Delta*life
  	@life -= 1
  end
  
  def dead?
  	@life == 0
  end
end
